using System;
using System.Text;
using System.Windows;
using System.Windows.Threading;
using ContactManager.Framework;

namespace ContactManager
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {
        public static bool IsDesignTime { get; set; }

        static App()
        {
            IsDesignTime = true;
        }

        public App()
        {
            this.DispatcherUnhandledException += OnDispatcherUnhandledException;
        }

        private static void OnDispatcherUnhandledException(object sender, DispatcherUnhandledExceptionEventArgs e)
        {
            StringBuilder sb = new StringBuilder();
            for (Exception exception = e.Exception; exception != null; exception = exception.InnerException)
            {
                sb.AppendLine(exception.Message);
            }
            sb.AppendLine(e.Exception.ToString());
            MessageBox.Show(sb.ToString());
            e.Handled = true;
        }

        protected override void OnStartup(StartupEventArgs e)
        {
            base.OnStartup(e);
            IsDesignTime = false;
            Client.Initialize();
        }
    }
}