﻿using System.Diagnostics;
using System.Reflection;

namespace ContactManager.Aspects
{
    internal static class ObjectDumper
    {
        public static void DumpObject(object o)
        {
            if (o == null)
            {
                Trace.TraceInformation("null");
                return;
            }

            Trace.TraceInformation(o.GetType().FullName + ": {" + SafeToString(o) + "}");
            Trace.Indent();
            foreach (FieldInfo field in o.GetType().GetFields(BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance))
            {
                Trace.TraceInformation("{0}={1}", field.Name, SafeToString(field.GetValue(o)));
            }
            Trace.Unindent();

        }

        private static string SafeToString(object o)
        {
            if (o == null) return "null";
            try
            {
                return o.ToString();
            }
            catch
            {
                return o.GetType().Name + " (error executing ToString)";
            }
        }
    }
}
