﻿using System;
using PostSharp.Aspects;

namespace Trace
{
    [Serializable]
    public sealed class TraceAttribute : OnMethodBoundaryAspect
    {
        public override void OnEntry(
            MethodExecutionArgs args)
        {
            System.Diagnostics.Trace.TraceInformation(  
                "Entering {0}.{1}.", 
                args.Method.DeclaringType.FullName, 
                args.Method.Name);
            System.Diagnostics.Trace.Indent();
        }

        public override void OnExit(
            MethodExecutionArgs args)
        {
            System.Diagnostics.Trace.Unindent();
            System.Diagnostics.Trace.TraceInformation(
                "Leaving {0}.{1}.", 
                args.Method.DeclaringType.FullName, 
                args.Method.Name);
         
        }

        public override void OnException(MethodExecutionArgs args)
        {
            System.Diagnostics.Trace.Unindent();
            System.Diagnostics.Trace.TraceInformation("Leaving {0}.{1} with exception {2}.", args.Method.DeclaringType.FullName, args.Method.Name, args.Exception.GetType().Name);
        }
    }
}
